Epoch: 1
ExclusiveArch: i386 ppc x86_64

%define gcj_support 		1
%define pkg_summary		Eclipse Subversion plug-in
%define section			free
%define eclipse_name 		eclipse
%define	changelog_major		0
%define changelog_minor		9
%define changelog_majmin	%{changelog_major}.%{changelog_minor}
%define changelog_micro   	37
%define eclipse_base   %{_datadir}/%{eclipse_name}
%define eclipse_lib_base %{_libdir}/%{eclipse_name}

# All arches line up except i386 -> x86
%ifarch %{ix86}
%define eclipse_arch    x86
%else
%define eclipse_arch   %{_arch}
%endif

Summary: 	%{pkg_summary} 
Name: 		%{eclipse_name}-subclipse
Version: 	%{changelog_majmin}.%{changelog_micro}_fc
Release:        1
License:	Apache
Group:		Text Editors/Integrated Development Environments (IDE)
URL:		http://subclipse.tigris.org/
Requires: eclipse-platform

Source0: site.%{changelog_majmin}.%{changelog_micro}.zip

BuildRequires: eclipse-pde
%if %{gcj_support}
BuildRequires:  gcc-java >= 4.0.0-1
BuildRequires:  java-1.4.2-gcj-compat-devel >= 1.4.2.0-40jpp_18rh
Requires(post,postun): java-1.4.2-gcj-compat >= 1.4.2.0-40jpp_18rh
%else
BuildRequires:	java-devel >= 1.4.2
%endif

BuildRoot: %{_tmppath}/%{name}-buildroot

%description
The Eclipse Subclipse package contains A Subversion Eclipse Plugin.

%prep
%setup -q -c 

%build

%if %{gcj_support}
  mkdir native
  pushd native
  for dir in features plugins; do
    mkdir $dir
    cp -p ../update/$dir/org.tigris.subversion.subclipse*.jar $dir/
  done
  %ifarch %{ix86} ppc
    find-and-aot-compile %{name}-native "-fPIC -fjni -O2"
  %else
    find-and-aot-compile %{name}-native "-fPIC -fjni -O1"
  %endif
  mv %{name}-native.tar.gz ..
  popd
%endif

%install
rm -rf ${RPM_BUILD_ROOT}

install -d -m755 ${RPM_BUILD_ROOT}/%{eclipse_base}

# Dump the files from the releng tarball into the build root
pushd update
for dir in features plugins; do
  mkdir $RPM_BUILD_ROOT/%{eclipse_base}/$dir
  cp -pr $dir/org.tigris.subversion.subclipse* $RPM_BUILD_ROOT/%{eclipse_base}/$dir/
done
popd

%if %{gcj_support}

  # Create plugins directory in eclipse lib base
  install -d -m755 $RPM_BUILD_ROOT/%{eclipse_lib_base}/plugins
  install -d -m755 $RPM_BUILD_ROOT/%{eclipse_lib_base}/features

  cd native
  tar zxf ../%{name}-native.tar.gz
  mv %{name}-native/plugins/* $RPM_BUILD_ROOT/%{eclipse_lib_base}/plugins
  mv %{name}-native/features/* $RPM_BUILD_ROOT/%{eclipse_lib_base}/features

  # Directory to hold all the .jar->.so mapping dbs
  install -d -m 755 $RPM_BUILD_ROOT`gcj-dbtool -p %{_libdir}`
  install -d -m 755 $RPM_BUILD_ROOT`gcj-dbtool -p %{_libdir}`.d

  # Create the pydev database
  gcjdbdir=$RPM_BUILD_ROOT`gcj-dbtool -p %{_libdir}`.d
  mkdir -p $gcjdbdir
  gcj-dbtool -n $gcjdbdir/%{name}.db 8000

  # Populate it
  for j in `find $RPM_BUILD_ROOT/%{eclipse_base} -name \*.jar`; do
	lib=`echo $j | sed "s:%{_datadir}:%{_libdir}:"`.so;
	lib=`dirname $lib`/lib`basename $lib`;
	ls -l $lib;
	if [ -f $lib ]; then
	  gcj-dbtool -f $gcjdbdir/%{name}.db \
	    $j `echo $lib | sed "s:$RPM_BUILD_ROOT/::"`;
	fi;
  done;

%endif

%clean 
rm -rf ${RPM_BUILD_ROOT}

%if %{gcj_support}
%post
/usr/bin/rebuild-gcj-db %{_libdir}

%postun
/usr/bin/rebuild-gcj-db %{_libdir}
%endif

%files
%defattr(-,root,root)
%{eclipse_base}/features/org.tigris.subversion.subclipse*
%{eclipse_base}/plugins/org.tigris.subversion.subclipse*
%if %{gcj_support}
%{eclipse_lib_base}/features/liborg.tigris.subversion.subclipse*
%{eclipse_lib_base}/plugins/liborg.tigris.subversion.subclipse*
%{_libdir}/gcj-4.0.1/classmap.db.d/%{name}.db
%endif

%changelog
* Thu Nov 24 2005 Peter Hanecak <hanecak@megaloman.sk> 1:0.9.37_fc-1
- Initial version (based on eclipse-changelog 2.0.1_fc)
